"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var querystring_1 = __importDefault(require("querystring"));
var relativeHTTPClient_1 = __importDefault(require("../http/relativeHTTPClient"));
var utils_1 = require("../utils");
/** This repository allows synchronization of data with current URL. */
function createURLDataSyncRepository(window, client) {
    function urlParams(additionalQuery) {
        return __assign({}, additionalQuery, querystring_1.default.parse(window.location.search.slice(1)));
    }
    var urlDataSync = {
        get: function (additionalQuery) {
            return client.fetch(window.location.pathname, {
                method: "get",
                params: urlParams(additionalQuery)
            });
        },
        getURLQuery: function () { return utils_1.getURLQuery(window.location); },
        onURLStateChange: function () {
            var _a;
            var args = [];
            for (var _i = 0; _i < arguments.length; _i++) {
                args[_i] = arguments[_i];
            }
            return (_a = window.historyWithCallbacks).onStateChange.apply(_a, args);
        },
        update: function (data) {
            return client.fetch(window.location.pathname, {
                data: data,
                method: "patch",
                params: urlParams()
            });
        },
        replaceURLQuery: function (query) {
            return utils_1.replaceURLQuery(window.historyWithCallbacks, query);
        }
    };
    return urlDataSync;
}
exports.createURLDataSyncRepository = createURLDataSyncRepository;
/* istanbul ignore next */
exports.default = createURLDataSyncRepository(window, relativeHTTPClient_1.default);
