"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
/** istanbul ignore next: Remember to call this only once per project. */
function createWorkarounds() {
    return {
        apply: function () {
            var pushCBs = {};
            var replaceCBs = {};
            var stateChangeCount = 0;
            var historyWithCallbacks = __assign({}, history, { pushState: function () {
                    var args = [];
                    for (var _i = 0; _i < arguments.length; _i++) {
                        args[_i] = arguments[_i];
                    }
                    history.pushState.apply(history, args);
                    Object.values(pushCBs).forEach(function (fn) { return fn.apply(void 0, ["pushState"].concat(args)); });
                }, replaceState: function () {
                    var args = [];
                    for (var _i = 0; _i < arguments.length; _i++) {
                        args[_i] = arguments[_i];
                    }
                    history.replaceState.apply(history, args);
                    Object.values(replaceCBs).forEach(function (fn) { return fn.apply(void 0, ["replaceState"].concat(args)); });
                }, onStateChange: function (fn) {
                    stateChangeCount += 1;
                    var stateKey = "" + stateChangeCount;
                    pushCBs[stateKey] = function () {
                        var args = [];
                        for (var _i = 0; _i < arguments.length; _i++) {
                            args[_i] = arguments[_i];
                        }
                        return fn.apply(void 0, args);
                    };
                    replaceCBs[stateKey] = function () {
                        var args = [];
                        for (var _i = 0; _i < arguments.length; _i++) {
                            args[_i] = arguments[_i];
                        }
                        return fn.apply(void 0, args);
                    };
                    return {
                        unsubscribe: function () {
                            delete pushCBs[stateKey];
                            delete replaceCBs[stateKey];
                        }
                    };
                } });
            window.historyWithCallbacks = historyWithCallbacks;
        }
    };
}
exports.createWorkarounds = createWorkarounds;
